#pragma once
#include <iostream>
#include <string.h>
#include <exception>
#include <system_error>
#include <iomanip>
#include "Exception.h"

class Vector;
class CSRMatrix 
{
private:
	int* columns;
	int* rowPointers;
	size_t elementsSize;
	size_t columnsSize;
	size_t rowPointersSize;
	double* elements;
public:
	CSRMatrix();
	CSRMatrix(/*double* element, int * column, int* rowPointer, */size_t elementsSize, size_t columnsSize, size_t rowPointersSize);// конструктор матрицы
	CSRMatrix(const CSRMatrix& other);
	~CSRMatrix();

	CSRMatrix& operator = (const CSRMatrix& matrix);
	friend CSRMatrix operator *(const CSRMatrix& matrix, double value);
	friend CSRMatrix operator *(double value, const CSRMatrix& matrix);
	Vector operator*(const Vector& vector) const;
	friend Vector operator*(const Vector& vector, const CSRMatrix& matrix);
	friend std::ostream& operator<<(std::ostream& output, const CSRMatrix& matrix);
	friend std::istream& operator>>(std::istream& input, CSRMatrix& matrix);

	size_t GetRows() const;
	size_t GetColumns() const;
	size_t NonZeroElements() const;
};



